#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#       untitled.py
#       
#       Copyright 2010 Frankie Chow <frankie@happysky>
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

import data
import pyglet
import graphics2d
import random

class eobble_s(object):
    def __init__(self, gw):
        self.gw = gw
        self.life = {'Book':100, 'Eat': 100, 'Run':100, 'Medica':100, 'Sleep': 100, 'Drink': 100}
        
        self.x = random.randint(10,538) 
        self.y = random.randint(10,508)
        self.aeobble_n = random.randint(0,  ( len(self.gw.eobbles_pool) - 1 ) ) 
        self.photo_img =  self.gw.eobbles_pool[ self.aeobble_n ]['img']
        self.life_value = self.gw.eobbles_pool[ self.aeobble_n ]['life_value']
        pyglet.image.load(filename='eobble-2', file=data.load('eobble-2.png'))

        self.color = (random.random(), random.random(), random.random(), random.random())
        self.backgroup = graphics2d.Rect(self.x, self.y,72,72, color=self.color)
        #self.backgroup = pyglet.image.create(72, 72)
        self.photo_img.anchor_x = 0
        self.photo_img.anchor_y = 0
        
        self.mouse_hit = False
        self.logo_x = 630
        self.logo_y = 300
        #self.life_a = ['Eat', 'Drink', 'Sleep', 'Medica', 'Run', 'Book']
        self.life_msg = {
            'Eat': pyglet.text.Label('Eat: ',
                  font_name='Free Mono', x = self.logo_x, y = self.logo_y - 40,
                  font_size=14, color=(125,0,0,255)),
            'Drink': pyglet.text.Label('Drink: ',
                  font_name='Free Mono', x = self.logo_x, y = self.logo_y - 60,
                  font_size=14, color=(0,125,0,255)),
            'Sleep': pyglet.text.Label('Sleep: ', 
                  font_name='Free Mono', x = self.logo_x, y = self.logo_y - 80,
                  font_size=14, color=(0,0,125,255)),
            'Medica': pyglet.text.Label('Medica: ',
                  font_name='Free Mono', x = self.logo_x, y = self.logo_y - 100,
                  font_size=14, color=(125,125,0,255)),
            'Run': pyglet.text.Label('Run: ',
                  font_name='Free Mono', x = self.logo_x, y = self.logo_y - 120,
                  font_size=14, color=(0,125,125,255)),
            'Book': pyglet.text.Label('Book: ',
                  font_name='Free Mono', x = self.logo_x, y = self.logo_y - 140,
                  font_size=14, color=(125,125,125,255))
                }                  
    
    def check_mouse(self):
        if self.x < self.gw.mouse_px < ( self.x + 72 ) and self.y < self.gw.mouse_py < ( self.y + 72 ):
            self.mouse_hit = True
        else:
            self.mouse_hit = False

    def draw(self):
        self.backgroup.draw()
        if self.check_life():
            if self.mouse_hit:
                graphics2d.Rect(self.logo_x, self.logo_y,72,72, color=self.color).draw()
                self.photo_img.blit(self.logo_x, self.logo_y)
                for k in self.gw.life_a:
                    self.life_msg[k].draw()
                if self.gw.status_key in self.life.keys() and self.gw.mouse_l_press:
                    self.gw.status_img[self.gw.status_key].blit(self.x, self.y)
                else:
                    self.photo_img.blit(self.x, self.y)
            else:
                self.photo_img.blit(self.x, self.y)
        else:
            self.gw.die_img.blit(self.x, self.y)
    
    def check_life(self):
        for k in self.life.keys():
            if self.life[k] < 0:
                return False
        return True 
    
    def update(self, dt):
        if self.gw.status_key in self.life.keys() and self.gw.mouse_l_press:
            if self.life[self.gw.status_key] < 100:
                self.add_speed = int( self.gw.timer_i / 60 ) + 20 
                self.life[self.gw.status_key] += dt * self.life_value[self.gw.status_key] * self.add_speed
        for k in self.gw.life_a:
            self.life[k] -= dt * self.life_value[k]
            self.life_msg[k].text = k + ': ' + '*' * int( int(self.life[k]) / 15 )
            
def main():
    
    return 0

if __name__ == '__main__':
    main()
