#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#       untitled.py
#       
#       Copyright 2010 Frankie Chow <frankie@happysky>
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

import pyglet
import game_logo
import game_area
import game_buttom
import eobble_s
import data

class game_window(pyglet.window.Window):
    def __init__(self, *args, **kwargs):
        super(game_window, self).__init__(800, 600, caption="Eobble Planet")
        #self.push_handlers(pyglet.window.event.WindowEventLogger())
        
        self.timer = 0
        self.end_time = -1

        self.batch = pyglet.graphics.Batch()
        self.glogo = game_logo.game_logo(630, 440)
        self.garea = game_area.garea(600,580)
        self.mouse_l_press = False
        self.mouse_px = -1
        self.mouse_py = -1
        self.cmd_button = game_buttom.cmd_buttom(self,620,50)
        
        #self.life_a = ['Eat', 'Drink', 'Sleep', 'Medica', 'Run', 'Book']
        self.life_a = ['Eat', 'Drink', 'Sleep']

        
        self.eobbles_pool = []
        self.eobbles_pool.append( {"img":pyglet.image.load(filename='aobble-1', file=data.load('aobble-1.png')),
			'life_value':{'Book':1, 'Eat': 2, 'Run':2, 'Medica':1, 'Sleep': 1, 'Drink': 1}} )
        self.eobbles_pool.append( {"img":pyglet.image.load(filename='aobble-2', file=data.load('aobble-2.png')),
			'life_value':{'Book':1, 'Eat': 1, 'Run':2, 'Medica':1, 'Sleep': 1, 'Drink': 2}} )

        
        self.eobbles_added = 0
        self.eobbles = []
        self.eobbles.append(eobble_s.eobble_s(self))
        
        self.life_img = {
            'Run': pyglet.image.load(filename='Run', file=data.load('eobble-roller-sw.png')),
            'Eat': pyglet.image.load(filename='Eat', file=data.load('eobble-rice-sw.png')),
            'Sleep': pyglet.image.load(filename='Sleep', file=data.load('eobble-sleep-sw.png')),
            'Medica': pyglet.image.load(filename='Medica', file=data.load('eobble-medica-sw.png')),
            'Book': pyglet.image.load(filename='Book', file=data.load('eobble-book-sw.png')),
            'Drink': pyglet.image.load(filename='Drink', file=data.load('eobble-drink-sw.png'))
            }
        self.status_img = {
            'Book':pyglet.image.load(filename='Book', file=data.load('eobble-reading.png')),
            'Medica':pyglet.image.load(filename='Medica', file=data.load('eobble-media-ing.png')),
            'Sleep':pyglet.image.load(filename='Medica', file=data.load('eobble-sleeping.png')),
            'Run':pyglet.image.load(filename='Medica', file=data.load('eobble-running.png')),
            'Drink':pyglet.image.load(filename='Drink', file=data.load('eobble-drinking.png')),
            'Eat':pyglet.image.load(filename='Drink', file=data.load('eobble-eating.png'))
            }
        
        self.die_img = pyglet.image.load(filename='Die', file=data.load('eobble-die.png'))
        self.status_key = "None"
        
        self.start_msg_x = self.width
        self.start_label = pyglet.text.Label('Eobble Planet',
          font_name='Free Mono', bold=True,
          font_size=96,
          x=self.start_msg_x, y=300,
          color=(0,125,0,125))
        self.key_start_label = pyglet.text.Label('press any key to start',
          font_name='Free Mono', bold=False,
          font_size=24,
          x=200, y=10,
          color=(255,125,0,125))
        self.start_game = False
        self.planet_img = pyglet.image.load(filename='Planet', file=data.load('eobble-planet.png'))
        self.timer_label = pyglet.text.Label('',
          font_name='Free Mono', bold=True,
          font_size=18,
          x=630, y=20,
          color=(0,125,0,125))
        self.end_label = pyglet.text.Label('Game Over',
          font_name='Free Mono', bold=True,
          font_size=48,
          x=200, y=500,
          color=(0,125,0,125))
        self.key_end_label = pyglet.text.Label('press any key to end',
          font_name='Free Mono', bold=False,
          font_size=24,
          x=200, y=10,
          color=(255,125,0,125))
        self.score_label = pyglet.text.Label('SCORE: ',
          font_name='Free Mono', bold=False,
          font_size=28,
          x=200, y=550,
          color=(255,125,0,125))
        self.end_game = False
        self.close_game = False
        
    def on_draw(self):
        if self.start_game and not self.end_game:
            self.clear()
            self.batch.draw()
            self.garea.draw()
            self.glogo.draw()
            self.cmd_button.draw()
            self.timer_label.draw()
            for e in self.eobbles:
                e.draw()
        elif self.end_game:
            self.clear()
            self.planet_img.blit(0,40)
            self.end_label.draw()
            self.key_end_label.draw()
            self.score_label.draw()
        else:
            self.clear()
            self.planet_img.blit(0, 40)
            self.start_label.x = self.start_msg_x
            self.start_label.draw()
            self.key_start_label.draw()
        
    def on_mouse_press(self, x, y, button, modifiers):
        if self.start_game:
            self.mouse_l_press = True
            self.mouse_px = x
            self.mouse_py = y
            if button == pyglet.window.mouse.LEFT:
                self.cmd_button.status_img = self.cmd_button.image_mouse_l_press
                self.cmd_button.set_cmd_cursor()
            
    def on_mouse_release(self, x, y, button, modifiers):
        if self.start_game:
            self.cmd_button.check_button_chose()
            self.mouse_l_press = False
            self.mouse_px = x
            self.mouse_py = y
            self.cmd_button.msg_label.text = ""

    def on_key_press(self, symbol, modifiers):
        if not self.start_game and not self.end_game:
            self.start_game = True
        elif self.end_game:
            self.close_game = True
    
    def update(self, dt):
        if self.start_game and not self.end_game:
            for e in self.eobbles:
                e.check_mouse()
                e.update(dt)
            self.timer += dt
            self.timer_i = int(self.timer)
            self.timer_label.text = "Time: %s" %self.timer_i
            if self.timer_i % 30 == 0 and self.eobbles_added != self.timer_i:
                self.eobbles_added = self.timer_i
                self.eobbles.append(eobble_s.eobble_s(self))
            for e in self.eobbles:
                if not e.check_life() and self.end_time < 0:
                    self.end_time = self.timer_i + 5
                    self.score_label.text += '%s' %self.timer_i
            if self.timer_i > self.end_time and self.end_time > 0:
                self.end_game = True
                
            if self.timer_i == 100:
                self.life_a.append('Medica')
                self.eobbles_pool = []
                self.eobbles_pool.append( {"img":pyglet.image.load(filename='eobble-1', file=data.load('eobble-1.png')),
                    'life_value':{'Book':1, 'Eat': 2, 'Run':1, 'Medica':1, 'Sleep': 2, 'Drink': 1} } )
                self.eobbles_pool.append( {"img":pyglet.image.load(filename='eobble-2', file=data.load('eobble-2.png')),
                    'life_value':{'Book':2, 'Eat': 1, 'Run':1, 'Medica':1, 'Sleep': 2, 'Drink': 2} } )
            elif self.timer_i == 250:
                self.life_a.append('Run')
                self.eobbles_pool = []
                self.eobbles_pool.append( {"img":pyglet.image.load(filename='eobble-3', file=data.load('eobble-3.png')),
                    'life_value':{'Book':2, 'Eat': 2, 'Run':2, 'Medica':1, 'Sleep': 2, 'Drink': 1} } )
                self.eobbles_pool.append( {"img":pyglet.image.load(filename='eobble-4', file=data.load('eobble-4.png')),
                    'life_value':{'Book':2, 'Eat': 1, 'Run':1, 'Medica':1, 'Sleep': 2, 'Drink': 1} } )
            elif self.timer_i == 450:
                self.life_a.append('Book')
                self.eobbles_pool = []
                self.eobbles_pool.append( {"img":pyglet.image.load(filename='eobble-6', file=data.load('eobble-6.png')),
                    'life_value':{'Book':2, 'Eat': 3, 'Run':1, 'Medica':1, 'Sleep': 2, 'Drink': 1} } )
                self.eobbles_pool.append( {"img":pyglet.image.load(filename='eobble-7', file=data.load('eobble-7.png')),
                    'life_value':{'Book':2, 'Eat': 1, 'Run':3, 'Medica':1, 'Sleep': 2, 'Drink': 2} } )
                self.eobbles_pool.append( {"img":pyglet.image.load(filename='eobble-8', file=data.load('eobble-8.png')),
                    'life_value':{'Book':2, 'Eat': 2, 'Run':2, 'Medica':1, 'Sleep': 2, 'Drink': 1} } ) 
            
        elif not self.start_game:
            self.start_msg_x -= dt * 160
            if self.start_msg_x < -1000:
                self.start_game = True
        elif self.close_game:
            self.close()

def main():
    
    return 0

if __name__ == '__main__':
    main()
